﻿; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; easyFTP ist kostenlos und darf sowohl privat als auch kommerziell verwendet werden. 
; Sofern das Programm nicht wesentlich verändert wurde müssen folgende Copyright-Texte mitgeliefert werden:
; Copyright © 2019 Ralf Pagel
; Die beigefügten DLLs wurden von Ray Siegl (RSBasic) entwickelt und im PureBasic Forum veröffentlicht. 
; Die DLL-Dateien sind kostenlos und dürfen sowohl privat als auch kommerziell verwendet werden. 
; Copyright © 2019 RSBasic.de
; http://forums.purebasic.com/german/viewtopic.php?f=11&t=30712
; Copyright (c) 2015 Robin Rodricks And FluentFTP Contributors
; https://github.com/robinrodricks/FluentFTP
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

EnableExplicit 

Structure RowStruc
  EntryID.l
  SizeFile.q
  SourceFile.s
  TargetFile.s
EndStructure

Dim Transferarray.RowStruc(0)
Global selProfile.s = "Profil1"
Global existProfiles.s
Global MWEvent.l
Global MsgWindow.l
Global CloseMainWindow.a
Global FileSz.q
Global Protocol.l = 1
Global TxtLocalstr.s = "PC"
Global TxtHoststr.s = "FTP-Server"
Global LocalFolder.s = GetHomeDirectory()
Global HostFolder.s = "/"
Global DnLdFolder.s = "www.mydomain.de/download"
Global HostURL.s = "www.mydomain.de"
Global HostPort.l = 21
Global HostUser.s
Global HostPass.s
Global NetID.l
Global UseCipher.l  = 0 ; 1/0
Global Overwrite.l = 0 ; 1/0 
Global AppPathForTemp.l = 1 ; 1/0
Global TooltipsOff.l = 0
Global CipherCode.s  
Global *CipherKey = AllocateMemory(32)
Global runs.a

Declare AddMsg(txt$)  ; Procedure s.u.
Declare RestoreHostList() ; Procedure s.u.
Declare PopupMenuEvent() ; Procedure s.u.
Declare.s DecodePW(strSource.s) ; Procedure s.u.
Declare MkCipherKey() ; Procedure s.u.

XIncludeFile "ftp.pbf"        ; Einbinden der Fenster-Definition
XIncludeFile "ftppref.pbf"    ; Einbinden der Fenster-Definition
XIncludeFile "ftphelp.pbf"    ; Einbinden der Fenster-Definition
XIncludeFile "ftpex.pbi"      ; Einbinden der SFTP- + FTPS-Funktionen

OpenMainWindow() ; opend the window at "ftp.pbf"

; put the pictures into the executable 
UsePNGImageDecoder()
CatchImage(0, ?key100)
CatchImage(1, ?pfeilrl)
CatchImage(2, ?pfeilrr)
CatchImage(3, ?pfeilgl)
CatchImage(4, ?pfeilgr)
CatchImage(5, ?recup)
CatchImage(6, ?recfolder)
CatchImage(7, ?recfile)
CatchImage(8, ?recfilec)
CatchImage(9, ?logo)
DataSection
  key100:
    IncludeBinary "key.png"
  pfeilrl:
    IncludeBinary "pfeilrl.png"
  pfeilrr:
    IncludeBinary "pfeilrr.png"
  pfeilgl:
    IncludeBinary "pfeilgl.png"
  pfeilgr:
    IncludeBinary "pfeilgr.png"
  recup:
    IncludeBinary "recup.bmp"
  recfolder:
    IncludeBinary "recfolder.bmp"
  recfile:
    IncludeBinary "recfile.bmp"
  recfilec:
    IncludeBinary "recfilec.bmp"
  logo:
    IncludeBinary "logo96.png"
EndDataSection

; read the selected Profil in the ini-file
If OpenPreferences("ftp.ini", #PB_Preference_GroupSeparator)
  PreferenceGroup("Global")
  selProfile = ReadPreferenceString("selProfile", selProfile)
  TxtLocalstr = ReadPreferenceString("TextLocal", TxtLocalstr)
  TxtHoststr = ReadPreferenceString("TextHost", TxtHoststr)
  Overwrite = ReadPreferenceLong("Overwrite", Overwrite)
  TooltipsOff = ReadPreferenceLong("TooltipsOff", TooltipsOff)
  AppPathForTemp = ReadPreferenceLong("AppPathForTemp", AppPathForTemp)
  ; Untersucht die Gruppen
  ExaminePreferenceGroups()
  While NextPreferenceGroup() ; Solange Gruppen existieren...
    If PreferenceGroupName() <> "Global"
      existProfiles = existProfiles + PreferenceGroupName() + "°°°"
    EndIf
  Wend
  ClosePreferences()
  If FindString(existProfiles, selProfile) = 0
    MessageRequester("Error", "The file 'ftp.ini' is destroyed. Can't find '" + selProfile + "'")
    End
  EndIf
Else
  ; if not open, try to create this file 
  If CreatePreferences("ftp.ini", #PB_Preference_GroupSeparator)
    PreferenceGroup("Global")
    WritePreferenceString("selProfile", selProfile)
    WritePreferenceString("TextLocal", TxtLocalstr)
    WritePreferenceString("TextHost", TxtHoststr)
    WritePreferenceLong("Overwrite", Overwrite)
    WritePreferenceLong("TooltipsOff", TooltipsOff)
    WritePreferenceLong("AppPathForTemp", AppPathForTemp)
    ClosePreferences()
  Else
    MessageRequester("Error", "The file 'ftp.ini' is not pesent and can not create.")
    End
  EndIf
EndIf

Procedure SetToolTips()
  If TooltipsOff
    ; delete tooltips
    GadgetToolTip(Image0, "")
    GadgetToolTip(HostList, "")
    GadgetToolTip(LocalList, "")
    GadgetToolTip(btnUpload, "")
    GadgetToolTip(btnDownload, "")
    GadgetToolTip(btnPreferences, "")
    GadgetToolTip(btnFTP, "")
    GadgetToolTip(PBar, "")
    GadgetToolTip(MsgList, "")
  Else  
    ; set tooltips
    If UseCipher = 1
      GadgetToolTip(Image0, "alle Dateien werden verschlüsselt")
    Else
      GadgetToolTip(Image0, "")
    EndIf  
    GadgetToolTip(HostList, "die Dateien auf dem Server - ein Rechtsklick zeigt ein Menü")
    GadgetToolTip(LocalList, "die Dateien hier auf dem PC - ein Rechtsklick zeigt ein Menü")
    GadgetToolTip(btnUpload, "die links markierten Dateien hochladen")
    GadgetToolTip(btnDownload, "die rechts markierten Dateien herunterladen")
    GadgetToolTip(btnPreferences, "Einstellungen für easyFTP")
    GadgetToolTip(btnFTP, "mit dem Server verbinden, oder die Verbindung trennen")
    GadgetToolTip(PBar, "zeigt den Fortschritt beim Up- und Download an")
    GadgetToolTip(MsgList, "zeigt Meldungen bzgl. der Verbindung mit dem Server an")
  EndIf
EndProcedure

Procedure ReadProfile()
  ; read the profile-preferences and set the global strings
  OpenPreferences("ftp.ini", #PB_Preference_GroupSeparator)
  PreferenceGroup(selProfile)
  LocalFolder = ReadPreferenceString("LocalFolder", LocalFolder)
  HostFolder = ReadPreferenceString("HostFolder", HostFolder)
  DnLdFolder = ReadPreferenceString("DnLdFolder", DnLdFolder)
  Protocol = ReadPreferenceLong("Protocol", 1)
  HostURL = ReadPreferenceString("HostURL", HostURL)
  HostPort = ReadPreferenceLong("HostPort", 21)
  HostUser = ReadPreferenceString("HostUser", "")
  HostPass = DecodePW(ReadPreferenceString("HostPass", ""))
  UseCipher = ReadPreferenceLong("UseCipher", 0)
  CipherCode = ReadPreferenceString("CipherCode", "")
  ClosePreferences()
EndProcedure

  
Procedure SetGadgets()
  If UseCipher
    If MkCipherKey()    ; if correct key
      SetGadgetState(Image0, ImageID(0)) ; show image
    Else        
      UseCipher = 0          ; if wrong key don't use cipher
      SetGadgetState(Image0, 0) ;  if wrong key delete image
    EndIf
  Else
    SetGadgetState(Image0, 0) ; delete image
  EndIf  
  ;
  SetWindowTitle(MainWindow, "easyFTP - [" + selProfile + "]")
  ;
  SetToolTips()
  ;
  SetGadgetText(txtLocal, TxtLocalstr)
  SetGadgetText(txtHost, TxtHoststr)
  ; kein Scrollbar
  SendMessage_(GadgetID(strHost),#EM_SHOWSCROLLBAR,#SB_HORZ,#False) 
  SendMessage_(GadgetID(strLocal),#EM_SHOWSCROLLBAR,#SB_HORZ,#False)
  ; show the recent folder at the header
  SetGadgetText(strLocal, LocalFolder)
  ; turn the local list to the recent folder
  SetGadgetText(LocalList, LocalFolder)
EndProcedure

; load Preferences ...
ReadProfile()
; ... and set the Gadgets
SetGadgets()
; set the arrow-images on the buttons
SetGadgetAttribute(btnDownload, #PB_Button_Image, ImageID(1))
SetGadgetAttribute(btnUpload, #PB_Button_Image, ImageID(2))
; remove local list colum 2 (type) for better match to the hostlist
RemoveGadgetColumn(LocalList, 2)
SetGadgetItemAttribute(LocalList, 0, #PB_Explorer_ColumnWidth, 155, 0)
SetGadgetItemAttribute(LocalList, 0, #PB_Explorer_ColumnWidth, 70, 1)
SetGadgetItemAttribute(LocalList, 0, #PB_Explorer_ColumnWidth, 100, 2)
; rename the host column
SetGadgetItemText(HostList, -1, "Name", 0)
SetGadgetItemAttribute(HostList, 0, #PB_ListIcon_ColumnWidth, 155, 0)
AddGadgetColumn(HostList, 1, "Größe", 70)
AddGadgetColumn(HostList, 2, "Letzte Änderung...", 100)
; Hostliste Spalte Dateigrösse rechtsbündig
Define Right.LV_COLUMN\mask=#LVCF_FMT
Right\fmt=#LVCFMT_RIGHT
SendMessage_(GadgetID(HostList), #LVM_SETCOLUMN, 1, @Right)

; create the Host-List-Popup-Menü
If CreatePopupMenu(0)
  MenuItem(1, "Umbenennen")
  MenuItem(2, "Verzeichnis erstellen")
  MenuItem(3, "Löschen")
  MenuBar()
  MenuItem(4, "Downloadlink kopieren")
EndIf

; create the Local-List-Popup-Menü
If CreatePopupMenu(1)
  MenuItem(11, "Umbenennen")
  MenuItem(12, "Verzeichnis erstellen")
  MenuItem(13, "Löschen")
  MenuBar()
  MenuItem(14, "Öffnen")
EndIf

; create the Profile-List-Popup-Menü
If CreatePopupMenu(2)
  MenuItem(21, "Neu")
  MenuItem(22, "Klonen")
  MenuItem(23, "Umbenennen")
  MenuItem(24, "Löschen")
EndIf


Procedure MkCipherKey()
  ; CipherCode prüfen und in den *CipherKey Speicherpuffer eintragen 
  Define ii.b
  Define FF.s
  For ii = 1 To 32
    FF = UCase(StringField(CipherCode, ii, " "))
    If RSet(Hex(Val("$" + FF), #PB_Byte), 2, "0") <> FF       ; check if it is hexcode
      MessageRequester("Fehler:", "Für den Schlüssel werden 32 Hexwerte durch Leerzeichen getrennt erwartet.")
      ProcedureReturn 0  
    EndIf  
    PokeA((*CipherKey + ii - 1), Val("$" + FF)) 
  Next
  ProcedureReturn 1  
EndProcedure


Procedure SetPrefWindowGadgeds()
  Define tmpstr.s
  tmpstr = GetGadgetItemText(comPrefProfil, GetGadgetState(comPrefProfil))
  OpenPreferences("ftp.ini", #PB_Preference_GroupSeparator)
  PreferenceGroup(tmpstr)
  SetGadgetState(comPrefProtocol, ReadPreferenceLong("Protocol", 1) - 1)
  SetGadgetText(strPrefHostURL, ReadPreferenceString("HostURL", HostURL))
  SetGadgetText(strPrefHostPort, Str(ReadPreferenceLong("HostPort", 21)))
  SetGadgetText(strPrefHostUser, ReadPreferenceString("HostUser", ""))
  SetGadgetText(strPrefHostPass, DecodePW(ReadPreferenceString("HostPass", "")))
  SetGadgetText(strPrefDnLdFolder, ReadPreferenceString("DnLdFolder", DnLdFolder))
  SetGadgetText(strPrefCipherCode, ReadPreferenceString("CipherCode", ""))
  SetGadgetState(chkPrefUseCipher, ReadPreferenceLong("UseCipher", 0))
  ClosePreferences()      
EndProcedure


Procedure PopupMenuEvent()
; eventhandler for both, the locallist menue event and the hostlist menue event
  #DelListLen = 20  ; Anzahl der Dateien, die maximal mit einem Streich gelöscht werrden können
  Define res.l
  Define temp.s
  Define dnldf.s
  Define hstfdr.s
  Define term.s
  Define aw.s
  Define row.l
  Define size.l
  Define ii.l
  Define cnt.l
  Dim rowtxt.s(0)
  ;
  Select EventMenu()     ; ausgewählten Menüeintrag bestimmen 
      
; ---(Host)------------  
      
    Case 1 ; Umbenennen (Host)
      row = GetGadgetState(HostList)
      temp = GetGadgetItemText(HostList, row, 0)
      If row > 0
        If GetGadgetItemData(HostList, row) = 7 Or GetGadgetItemData(HostList, row) = 8 ; file + ciphered file
          term = "Datei"
        Else  
          term = "Verzeichnis"
        EndIf  
        aw = InputRequester(term + " umbenennen", "Neuer " + term + "name:", temp)
        If aw > ""
          If RenameFTPFileEx(NetID, Hostfolder + temp, Hostfolder + aw, @ErrorOutput$)
            AddMsg(term + " umbenannt")
            RestoreHostList() 
          EndIf  
        EndIf
      EndIf
    Case 2 ; Verzeichnis erstellen (Host)
      temp = InputRequester("Verzeichnis erstellen", "Bitte geben Sie den Verzeichnisnamen ein:", "")
      If temp > ""
        If CreateFTPDirectoryEx(NetID, Hostfolder + temp, @ErrorOutput$)
          AddMsg("Verzeichnis ''" + temp + "'' erstellt")
          RestoreHostList() 
        EndIf  
      EndIf
    Case 3 ; Löschen (Host)
      row = GetGadgetState(HostList) ; gibt den ersten ausgewählten Eintrag-Index zurück
      If row > 0
        Select GetGadgetItemData(HostList, row)
          Case 7, 8 ; file, ciphered file
            cnt = 0
            temp = ""
            For ii = row To CountGadgetItems(HostList) - 1 ; die Liste vom ersten selektiertem Eintrag bis zum Ende
              If GetGadgetItemState(HostList, ii) & #PB_ListIcon_Selected 
                If GetGadgetItemData(HostList, ii) = 7 Or GetGadgetItemData(HostList, row) = 8 ; file + ciphered file
                  ReDim rowtxt(cnt)
                  rowtxt(cnt) = GetGadgetItemText(HostList, ii ,0)
                  If cnt < #DelListLen
                    temp + #CRLF$ + Chr(34) + GetGadgetItemText(HostList, ii ,0) + Chr(34)
                  ElseIf cnt = #DelListLen
                    temp + #CRLF$ + " ... " + #CRLF$ + "(Die anderen können hier aus Platzgründen" + #CRLF$ + "nicht dargestellt werden.)" 
                  EndIf
                  cnt + 1
                EndIf  
              EndIf
            Next
            If MessageRequester("Frage:", "Es wurde(n) " + Str(cnt) + " Datei(en) markiert." + #CRLF$ +
                                  "Wollen Sie die wirklich löschen?" + #CRLF$ +
                                temp, #PB_MessageRequester_YesNo | #MB_ICONQUESTION) = #PB_MessageRequester_Yes
              For ii = 0 To (cnt - 1)
                If DeleteFTPFileEx(NetID, rowtxt(ii), @ErrorOutput$) 
                  AddMsg("Datei ''" + rowtxt(ii) + "'' gelöscht")
                Else
                  Break
                EndIf
              Next
              RestoreHostList()
            EndIf
          Case 6 ; folder
            temp = GetGadgetItemText(HostList, row, 0)
            If MessageRequester("Frage:", "Wollen Sie folgendes Verzeichnis wirklich löschen?" + 
                                            #CRLF$ + #CRLF$ + Chr(34) + temp + Chr(34),  
                                            #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
              res = DeleteFTPDirectoryEx(NetID, temp, @ErrorOutput$)
              If res <> 0  ; erfolgreich
                AddMsg("Verzeichnis ''" + temp + "'' gelöscht")
                RestoreHostList()
              Else ; Verzeichnis ist nicht leer
                MessageRequester("Fehler:", "Konnte das Verzeichnis nicht löschen." + #LF$ + 
                                            "Das Verzeichnis ist vermutlich nicht leer.", 0)
              EndIf  
            EndIf
        EndSelect 
      EndIf  
    Case 4 ; Downloadlink (Host)
      row = GetGadgetState(HostList)
      temp = GetGadgetItemText(HostList, row, 0)
      If row > 0
        If GetGadgetItemData(HostList, row) = 7 Or GetGadgetItemData(HostList, row) = 8 ; file + ciphered file
          ; /..  im String bedeutet, dass der nächste Pfadabschnitt gelöscht wird
          dnldf = DnLdFolder
          hstfdr = HostFolder
          While Right(dnldf, 3) = "/.."                       ; wenn Zeichen enthalten ...
            dnldf = Mid(dnldf, 1, Len(dnldf)-3)               ; ... Zeichen entfernen ...
            hstfdr = Mid(hstfdr, FindString(hstfdr, "/", 2))  ; ... und nächsten Pfadabschnitt löschen
          Wend
          SetClipboardText(dnldf + hstfdr + temp)
          If TooltipsOff = 0
            MsgWindow = OpenWindow(#PB_Any, 0, 0, 300, 30, "", #PB_Window_BorderLess | #PB_Window_WindowCentered, WindowID(MainWindow))
         ;   SetWindowColor(MsgWindow, #Yellow)
            Define msg = TextGadget(#PB_Any, 0, 7, 300, 20, "Der Downloadlink wurde in die Zwischenablage kopiert.", #PB_Text_Center) 
         ;   SetGadgetColor(msg, #PB_Gadget_BackColor, #Yellow)
            SetActiveWindow(MainWindow)
            AddWindowTimer(MainWindow, 123, 2500)
          EndIf
        Else
          MessageRequester("Fehler:", "Es können nur Dateien heruntergeladen werden, keine Verzeichnisse.", 0)
        EndIf
      EndIf
      
; ---(local)------------      
      
    Case 11 ; Umbenennen   (local)
      row = GetGadgetState(LocalList)
      temp = GetGadgetItemText(LocalList, row, 0)
      If row > 0
        If GetGadgetItemState(LocalList, row) & #PB_Explorer_File ; file
          term = "Datei"
        Else  
          term = "Verzeichnis"
        EndIf  
        aw = InputRequester(term + " umbenennen", "Neuer " + term + "name:", temp)
        If aw > ""
          RenameFile(LocalFolder + temp, LocalFolder + aw)
        EndIf
      EndIf
    Case 12 ; Verzeichnis erstellen  (local)
      temp = InputRequester("Verzeichnis erstellen", "Bitte geben Sie den Verzeichnisnamen ein:", "")
      If temp > ""
        CreateDirectory(LocalFolder + temp)
      EndIf
    Case 13 ; Löschen  (local)
      row = GetGadgetState(LocalList) ; gibt den ersten ausgewählten Eintrag-Index zurück
      If row > 0
        If GetGadgetItemState(LocalList, row) & #PB_Explorer_File ; file
          cnt = 0
          temp = ""
          For ii = row To CountGadgetItems(LocalList) - 1 ; die Liste vom ersten selektiertem Eintrag bis zum Ende
            If GetGadgetItemState(LocalList, ii) & #PB_Explorer_Selected 
              If GetGadgetItemState(LocalList, ii) & #PB_Explorer_File ; file
                ReDim rowtxt(cnt)
                rowtxt(cnt) = GetGadgetItemText(LocalList, ii ,0)
                If cnt < #DelListLen
                  temp + #CRLF$ + Chr(34) + GetGadgetItemText(LocalList, ii ,0) + Chr(34)
                ElseIf cnt = #DelListLen
                  temp + #CRLF$ + " ... " + #CRLF$ + "(Die anderen können hier aus Platzgründen" + #CRLF$ + 
                         "nicht dargestellt werden.)" 
                EndIf
                cnt + 1
              EndIf  
            EndIf
          Next
          If MessageRequester("Frage:", "Es wurde(n) " + Str(cnt) + " Datei(en) markiert." + #CRLF$ +
                                "Wollen Sie die wirklich löschen?" + #CRLF$ +
                                temp, #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
            For ii = 0 To (cnt - 1)  
              If DeleteFile(LocalFolder + rowtxt(ii)) = 0
                Break
              EndIf
            Next
          EndIf
        EndIf
        If GetGadgetItemState(LocalList, row) & #PB_Explorer_Directory ; folder
          temp = GetGadgetItemText(LocalList, row, 0)
          If MessageRequester("Frage:", "Wollen Sie folgendes Verzeichnis wirklich löschen?" + 
                                          #CRLF$ + #CRLF$ + Chr(34) + temp + Chr(34),  
                                          #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
            cnt = -2
            If ExamineDirectory(0, LocalFolder + temp, "*.*")  
              While NextDirectoryEntry(0)
                cnt + 1
              Wend
              FinishDirectory(0)
            EndIf
            If cnt
              MessageRequester("Fehler:", "Das Verzeichnis ist nicht leer." + #CRLF$ +
                                "Löschen Sie zuerst die darin enthaltenen Dateien.", 0)
            Else
              DeleteDirectory(LocalFolder + temp, "*.*")
            EndIf
          EndIf
        EndIf
      EndIf  
    Case 14 ; ausführen/öffnen  (nur unter Windows im Menü sichtbar)
      row = GetGadgetState(LocalList)
      temp = GetGadgetItemText(LocalList, row, 0)
      If row > 0
        If GetGadgetItemState(LocalList, row) & #PB_Explorer_File ; file
          RunProgram(LocalFolder + temp)
        EndIf
      EndIf
      
; ---(Preferences-Profil)------------      
      
    Case 21 ; Neu (Profil)
      temp = InputRequester("easyFTP", "Bitte den Namen für das neue Profil eingeben:", "")
      If temp > ""
        AddGadgetItem(comPrefProfil, -1, temp)        
        SetGadgetState(comPrefProfil, CountGadgetItems(comPrefProfil) - 1)
        SetActiveGadget(comPrefProfil)
        SetGadgetText(strPrefHostURL, "www.mydomain.de")
        SetGadgetText(strPrefHostPort, "21")
        SetGadgetText(strPrefHostUser, "")
        SetGadgetText(strPrefHostPass, "")
        SetGadgetText(strPrefDnLdFolder, "www.mydomain.de/download")
        SetGadgetText(strPrefCipherCode, "")
        SetGadgetState(chkPrefUseCipher, 0)        
      EndIf
    Case 22 ; Klonen (Profil)
      temp = GetGadgetItemText(comPrefProfil, GetGadgetState(comPrefProfil))
      AddGadgetItem(comPrefProfil, -1, temp + " - Kopie")        
      SetGadgetState(comPrefProfil, CountGadgetItems(comPrefProfil) - 1)
      SetActiveGadget(comPrefProfil)
    Case 23 ; Umbenennen (Profil)
      ii = GetGadgetState(comPrefProfil)
      temp = GetGadgetItemText(comPrefProfil, ii)
      aw = InputRequester("easyFTP", "Neuen Namen eingeben:", temp)
      If aw <> ""
        SetGadgetItemText(comPrefProfil, ii, aw)
        SetGadgetState(comPrefProfil, ii)
        SetActiveGadget(comPrefProfil)
      EndIf  
    Case 24 ; Löschen (Profil)
      temp = GetGadgetItemText(comPrefProfil, GetGadgetState(comPrefProfil))
      If MessageRequester("easyFTP", "Wollen Sie das Profil '" + temp + "' wirklich löschen?", #PB_MessageRequester_YesNo | #MB_ICONQUESTION) = #PB_MessageRequester_Yes
        RemoveGadgetItem(comPrefProfil, GetGadgetState(comPrefProfil)) 
        SetGadgetState(comPrefProfil, 0)
        SetActiveGadget(comPrefProfil)
        SetPrefWindowGadgeds()  
      EndIf  
  EndSelect
EndProcedure 


Procedure.s EncodePW(strSource.s)
  ; encode Password for ini-file
  If StringByteLength(strSource) = 0 ; necessary, else an error occur at "Base64Encoder"
    ProcedureReturn ""
  EndIf  
  Define *SourceBuffer = UTF8(strSource)
  Define temp.s = Base64Encoder(*SourceBuffer, MemorySize(*SourceBuffer))
  Define Encoded.s = ReverseString(temp)
  ProcedureReturn Encoded
EndProcedure  


Procedure.s DecodePW(strSource.s)
  ; decode password for ini-file
  If StringByteLength(strSource) = 0 ; necessary, else an error occur at "Base64Decoder"
    ProcedureReturn ""
  EndIf  
  Define temp.s = ReverseString(strSource)
  Define length.l = Len(temp) + 64
  Define *DecodedBuffer = AllocateMemory(length)
  Base64Decoder(temp, *DecodedBuffer, length)
  Define Decoded.s = PeekS(*DecodedBuffer, -1, #PB_UTF8)
  ProcedureReturn Decoded
EndProcedure


Procedure AddMsg(txt$)
  ; add an entry to the list and scroll, that it is visible
  txt$ = RTrim(txt$, Chr(10))
  txt$ = FormatDate("%hh:%ii:%ss", Date()) + "   " + RTrim(txt$, Chr(13))
  AddGadgetItem (MsgList, -1, txt$)
  SendMessage_(GadgetID(MsgList),#EM_SCROLL,#SB_BOTTOM,0)
EndProcedure 


Procedure FileSizeToByte()
  ; show the filesize like the HostList
  Define ii.l
  Define fsize.l
  For ii = 1 To  (CountGadgetItems(LocalList) - 1)
    fsize = FileSize(LocalFolder + GetGadgetItemText(LocalList, ii, 0))
    If fsize > 0
      SetGadgetItemText(LocalList, ii, Str(fsize), 1)
    EndIf  
  Next  
EndProcedure


Procedure LocalStringEvent(EventType)
  ; Return als Eingabetaste nutzen
  Define temp.s
  temp = GetGadgetText(strLocal) 
  If FindString(temp, #CRLF$)
    temp = RemoveString(temp, #CRLF$) 
    LocalFolder = GetPathPart(temp)   ; definitiv Backslash am Ende
    SetGadgetText(strLocal, LocalFolder)
    SendMessage_(GadgetID(strLocal), #EM_SETSEL, $fffffff, $fffffff) ; Cursor ans Ende
    SetGadgetText(LocalList, LocalFolder)
    FileSizeToByte()
  EndIf
EndProcedure


Procedure LocalListEvent(EventType)
  ; set the variable 'LocalFolder' in accordance with the selected folder
  If runs : ProcedureReturn : EndIf
  If GetGadgetText(LocalList) <> LocalFolder
    LocalFolder = GetGadgetText(LocalList)
    SetGadgetText(strLocal, LocalFolder)
  EndIf  
  ; show the filesize like the HostList
  FileSizeToByte()
  ; at right click show menu
  If EventType() = #PB_EventType_RightClick
    DisplayPopupMenu(1, WindowID(MainWindow))
  EndIf
EndProcedure


Procedure FTPDirectoryGoUp()
  ; geht im Verzeichnisbaum nach oben
  If NetID = 1 
    If SetFTPDirectoryEx(NetID, "..", @ErrorOutput$)       
      Define temp.s
      temp = ReverseString(HostFolder)
      temp = Mid(temp, FindString(temp, "/" , 2))
      HostFolder = ReverseString(temp)
      AddMsg("Wechsel in das übergeordnete Verzeichnis")
      RestoreHostList()
      ProcedureReturn 1
    EndIf
  EndIf
  ProcedureReturn 0    
EndProcedure


Procedure FTPDirectoryGoFolder(fname.s)
  ; geht im Verzeichnisbaum nach oben
  If NetID = 1 
    If SetFTPDirectoryEx(NetID, HostFolder + fname + "/", @ErrorOutput$)
      HostFolder = HostFolder + fname + "/"
      AddMsg("Wechsel in das Verzeichnis ''" + fname + "''")
      RestoreHostList()
      ProcedureReturn 1
    EndIf
  EndIf
  ProcedureReturn 0 
EndProcedure


Procedure HostListEvent(EventType)
  ;
  If runs : ProcedureReturn : EndIf
  Define dtype.b ; 5 = up, 6 = folder, 7 = file
  Define row.l
  ; at doubleclick change directory path
  If EventType() = #PB_EventType_LeftDoubleClick
    row = GetGadgetState(HostList)
    dtype = GetGadgetItemData(HostList, row) 
    If dtype = 5 ; up
      FTPDirectoryGoUp()
    EndIf
    If dtype = 6 ; folder
      FTPDirectoryGoFolder(GetGadgetItemText(HostList, row ,0))
    EndIf
  EndIf  
  ; at right click show menu
  If EventType() = #PB_EventType_RightClick
    DisplayPopupMenu(0, WindowID(MainWindow))
  EndIf
EndProcedure


Procedure HostStringEvent(EventType)
  ; Return als Eingabetaste nutzen
  Define temp.s, fname.s, pos.i
  temp = GetGadgetText(strHost) 
  If FindString(temp, #CRLF$)
    temp = RemoveString(temp, #CRLF$) 
    pos = FindString(ReverseString(temp), "/") - 1
    temp = Left(temp, Len(temp) - pos) 
    SetGadgetText(strHost, temp)
    SendMessage_(GadgetID(strHost), #EM_SETSEL, $fffffff, $fffffff) ; Cursor ans Ende
    ; Wechsel im Verzeichnisbaum nach oben
    While Len(temp) < Len(HostFolder)
      FTPDirectoryGoUp()
    Wend
    ; Wechsel in Unterverzeichnisse
    While Len(temp) > Len(HostFolder)
      fname = RemoveString(temp, HostFolder, #PB_String_NoCase, 1, 1)
      fname = Left(fname, FindString(fname, "/") - 1)
      FTPDirectoryGoFolder(fname)
    Wend
  EndIf
EndProcedure


Procedure RestoreHostList()
  ; shows the current server directory
  Define dSize.s, dDate.s, dName.s
  Define cntr.i
  ; set the "up" row
  ClearGadgetItems(HostList)
  AddGadgetItem (HostList, 0, ".." + #LF$ + "" + #LF$ + "", ImageID(6))
  SetGadgetItemData(HostList, 0, 5)  ; 5 = up
  cntr.i = 1
  ; set the folders at first
  If ExamineFTPDirectoryEx(NetID, @ErrorOutput$) 
    While NextFTPDirectoryEntryEx(NetID, @ErrorOutput$)  
      FTPDirectoryEntryNameEx(NetID, @FileName$, @ErrorOutput$)
      dName = FileName$
      ; in die HostList eintragen    
      ; ItemData: 5 = up, 6 = folder, 7 = file, 8 = cipheredfile
      If FTPDirectoryEntryTypeEx(NetID, @ErrorOutput$) = #PB_FTP_Directory
        Select dName
          Case ".", ".."
            ; don't show this entry
          Default
            AddGadgetItem (HostList, cntr, dName + #LF$ + "" + #LF$ + "", ImageID(6))
            SetGadgetItemData(HostList, cntr, 6)  ; 6 = folder
            cntr + 1 
        EndSelect    
      EndIf    
    Wend
    FinishFTPDirectoryEx(NetID, @ErrorOutput$)
  EndIf
  ; at second set the files
  If ExamineFTPDirectoryEx(NetID, @ErrorOutput$) 
    While NextFTPDirectoryEntryEx(NetID, @ErrorOutput$)  
      FTPDirectoryEntryNameEx(NetID, @FileName$, @ErrorOutput$)
      dName = FileName$
      dSize = Str(FTPDirectoryEntrySizeEx(NetID, @ErrorOutput$))
      dDate = FormatDate("%dd.%mm.%yyyy %hh:%ii", FTPDirectoryEntryDateEx(NetID, @ErrorOutput$))
      ; in die HostList eintragen    
      ; ItemData: 5 = up, 6 = folder, 7 = file, 8 = cipheredfile
      If FTPDirectoryEntryTypeEx(NetID, @ErrorOutput$) = #PB_FTP_File
        Select GetExtensionPart(dName)
          Case "aes"
            AddGadgetItem (HostList, cntr, dName + #LF$ + dSize + #LF$ + dDate, ImageID(8))
            SetGadgetItemData(HostList, cntr, 8)  ;  8 = cipheredfile
            cntr + 1
          Default  
            AddGadgetItem (HostList, cntr, dName + #LF$ + dSize + #LF$ + dDate, ImageID(7))
            SetGadgetItemData(HostList, cntr, 7)  ; 7 = file
            cntr + 1
        EndSelect    
      EndIf    
    Wend
    FinishFTPDirectoryEx(NetID, @ErrorOutput$)
  EndIf  
  SetGadgetText(strHost, HostFolder) ; show the current folder string
  If GetActiveGadget() = strHost
    SendMessage_(GadgetID(strHost), #EM_SETSEL, $fffffff, $fffffff) ; Cursor ans Ende
  EndIf  
EndProcedure


Procedure btnFTPEvent(EventType)
  ; establish or close connection to the ftp server
  If runs : ProcedureReturn : EndIf
  Define temp.s
  ; versehentlichen Doppelklick unterbinden
  Static LastStartTime
  If (ElapsedMilliseconds() < LastStartTime + 1000) And (ElapsedMilliseconds() > 0)
    SetGadgetState(btnFTP, 1 - GetGadgetState(btnFTP)) ; den Toggelbutton wieder zurückschalten und ...
    ProcedureReturn  ; ... dann sofortiger Rücksprung (bei mehr als 1 Klick pro Sekunde)
  EndIf 
  LastStartTime = ElapsedMilliseconds()
  ; Button auswerten
  If GetGadgetState(btnFTP) ; gadget is a toggle button, 1 = establish connection
    ClearGadgetItems(MsgList)
    NetID = 1   ; #PB_Any funktioniert nicht
    If OpenFTPEx(NetID, Protocol, HostURL, HostPort, HostUser, HostPass, #PB_UTF8, @ErrorOutput$)
      AddMsg("Verbunden")
      RestoreHostList()
    Else
      MessageRequester("Fehler:", "Es konnte keine Verbindung mit dem Server hergestellt werden.", 0)
      SetGadgetState(btnFTP, 0)
      ClearGadgetItems(MsgList)
      NetID = 0
      ProcedureReturn
    EndIf
    SetGadgetText(btnFTP, "Trennen")
    SetGadgetAttribute(btnDownload, #PB_Button_Image, ImageID(3))
    SetGadgetAttribute(btnUpload, #PB_Button_Image, ImageID(4))
  Else  
    If NetID
      CloseFTPEx(NetID, @ErrorOutput$)
      NetID = 0
      AddMsg("Verbindung geschlossen")
      ClearGadgetItems(HostList)
      HostFolder = "/"
      SetGadgetText(strHost, "")
    EndIf
    SetGadgetText(btnFTP, "Verbinden")
    SetGadgetAttribute(btnDownload, #PB_Button_Image, ImageID(1))
    SetGadgetAttribute(btnUpload, #PB_Button_Image, ImageID(2))
  EndIf  
EndProcedure


Procedure TransferComplete()
  ; wartet auf das Ende des Up- oder Downloads und zeigt dabei den den Fortschritt am ProgressBar an
  ; wenn der Transfer nicht beginnt oder stockt wird nach 10s abgebrochen und "0" zurückgeliefert
  ; sonst wird "1" zurückgeliefert 
  Define PercentValue = 0
  Define TransferRate = 0
  Define EstimatedTime = 0
  Define oldPercentValue = 0
  Define cntr.a
  ;
  Repeat
    FTPProgressEx(NetID, @PercentValue, @TransferRate, @EstimatedTime, @ErrorOutput$)
    If PercentValue > oldPercentValue
      SetGadgetState(PBar, PercentValue)   ; Progressbar
      If PercentValue = 100
        SetGadgetState(PBar, 0)   ; Progressbar = 0
        ProcedureReturn 1         ; Übertragung abgeschlossen
      EndIf
      oldPercentValue = PercentValue
      cntr = 0
    Else
      cntr + 1                   ; nur wenn der Transfer nicht läuft 
    EndIf
    Delay(100)
  Until cntr >= 100         ; Abbruch
  SetGadgetState(PBar, 0)   ; Progressbar = 0
  ProcedureReturn 0         ; Zeitüberschreitung
EndProcedure  


Procedure FileDownload(param)
  ; the files, contain in the Transferarray, are successive download 
  Shared Transferarray()
  Define temppath.s
  Define ii.l
  Define ref.s
  Define fsize.q, nfsize.q
  Define *Buffer
  Define *Plaintext
  ; den Pfad für die temporäre Datei einstellen
  If AppPathForTemp 
    temppath = GetCurrentDirectory()
  Else  
    temppath = GetTemporaryDirectory()
  EndIf
  ; in dieser Schleife werden alle Dateien heruntergeladen
  For ii = 0 To ArraySize(Transferarray())
    If Transferarray(ii)\EntryID > 0
      ; File herunterladen
      If ReceiveFTPFileEx(NetID, Transferarray(ii)\SourceFile, temppath + "temp", 1, @ErrorOutput$)  
        If Not TransferComplete()
          MessageRequester("Fehler:", "Die Datei konnte nicht heruntergeladen werden.")
          Transferarray(ii)\EntryID = 0 ; diese Datei ausschließen
          runs = #False : ProcedureReturn 0
        EndIf  
        AddMsg("Download ''" + GetFilePart(Transferarray(ii)\SourceFile) + "''")
      Else
        MessageRequester("Fehler:", "Die Datei konnte nicht heruntergeladen werden.")
        Transferarray(ii)\EntryID = 0 ; diese Datei ausschließen
        runs = #False : ProcedureReturn 0
      EndIf 
      ; temporäres File entschlüsseln oder kopieren, danach löschen
      Transferarray(ii)\EntryID = 0 ; diese Datei zukünftig ausschließen
      If (GetExtensionPart(Transferarray(ii)\SourceFile) = "aes") ; wenn verschlüsselt
        ; den Dateiinhalt in den Arbeitsspeicher laden und die temporäre Datei löschen
        If OpenFile(0, temppath + "temp")
          fsize = Lof(0)
          *Buffer = AllocateMemory(fsize + 1)
          ReadData(0, *Buffer, fsize)
          CloseFile(0)
          DeleteFile(temppath + "temp")
          *Plaintext = AllocateMemory(fsize - 16)
          ; den Speicherinhalt entschlüsseln 
          If Not AESDecoder(*Buffer, *Plaintext, fsize - 16, *CipherKey, 256, *Buffer + fsize - 16, #PB_Cipher_CBC) ; entschlüsseln
            FreeMemory(*Buffer)
            FreeMemory(*Plaintext)
            MessageRequester("Fehler:", "Die temporäre Datei konnte nicht entschlüsselt werden.")
            runs = #False : ProcedureReturn 0
          EndIf
          ; die Zieldatei erzeugen und mit dem Speicherinhalt füllen  
          CreateFile(1, Transferarray(ii)\TargetFile)
          nfsize = fsize - 32   ;  - IVector  - unvolständigen Block
          If PeekA(*Buffer + fsize - 1) = 0 : nfsize + 16 : EndIf   ; + 16 wenn Modulo-Wert = 0
          nfsize + PeekA(*Buffer + fsize - 1)  ;  + Modulo-Wert
          WriteData(1, *Plaintext, nfsize)
          CloseFile(1)
          FreeMemory(*Buffer)
          FreeMemory(*Plaintext)
        Else
          MessageRequester("Fehler:", "Die temporäre Datei konnte nicht geöffnet werden.")
          runs = #False : ProcedureReturn 0
        EndIf
      Else
        ; die temporäre Datei kopieren und dann löschen
        If CopyFile(temppath + "temp", Transferarray(ii)\TargetFile)
          DeleteFile(temppath + "temp") ; temporäre Datei löschen
        Else
          MessageRequester("Fehler:", "Die temporäre Datei konnte nicht kopiert werden.")
          runs = #False : ProcedureReturn 0
        EndIf
      EndIf
    EndIf  
  Next
  runs = #False : ProcedureReturn 1
EndProcedure


Procedure btnDownloadEvent(EventType)
  ; file-download, multiple selection possible
  If runs : ProcedureReturn : EndIf
  If NetID
    Shared Transferarray()
    Define ii.l
    Define cnt.l
    Define hfile.s
    Define xfile.s
    For ii = 1 To CountGadgetItems(HostList) - 1
      If GetGadgetItemState(HostList, ii) & #PB_ListIcon_Selected 
        If GetGadgetItemData(HostList, ii) > 6 ; if it's a file
          ReDim Transferarray.RowStruc(cnt)
          Transferarray(cnt)\EntryID = ii
          hfile = GetGadgetItemText(HostList, ii, 0)
          Transferarray(cnt)\SizeFile = Val(GetGadgetItemText(HostList, ii ,1))
          If (GetExtensionPart(hfile) = "aes") And (UseCipher = 0) ; wenn verschlüsselt
            MessageRequester("Fehler:", "Um verschlüsselte Dateien (.aes) herunterzuladen muß die" + #LF$ + 
                                        "AES-256-Verschlüsselung eingeschaltet sein.")
            ProcedureReturn  
          EndIf
          ; file overwrite or not overwrite
          xfile = LocalFolder + hfile
          If GetExtensionPart(xfile) = "aes" : xfile = Left(xfile, Len(xfile) - 4) : EndIf ; chop the extension ".aes"
          If (FileSize(xfile) >= 0) And (Overwrite = 0)
            If MessageRequester("Frage:", "''" + GetFilePart(xfile) + "''" + #LF$ + #LF$ + 
                                      "Diese Datei existiert bereits im Zielverzeichnis." + #LF$ + 
                                      "Soll sie überschrieben werden?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_No
              ProcedureReturn
            EndIf  
          EndIf
          ; load array
          Transferarray(cnt)\SourceFile = HostFolder + hfile
          Transferarray(cnt)\TargetFile = xfile
          cnt + 1
        EndIf
      EndIf
    Next
    runs = #True
    CreateThread(@FileDownload(), 0)
  EndIf 
EndProcedure


Procedure FileUpload(param)
  ; the files, contain in the Transferarray, are successive upload
  Shared Transferarray()
  Define ii.l
  Define.q fsize, blks
  Define *Buffer
  Define *CiphBuff
  Define temppath.s
  ; den Pfad für die temporäre Datei einstellen
  If AppPathForTemp 
    temppath = GetCurrentDirectory()
  Else  
    temppath = GetTemporaryDirectory()
  EndIf
  ;
  For ii = 0 To ArraySize(Transferarray())
    If Transferarray(ii)\EntryID > 0
      ; Datei in den Arbeitsspeicher laden
      fsize = FileSize(Transferarray(ii)\SourceFile)
      *Buffer = AllocateMemory(fsize + 32)
      If ReadFile(0, Transferarray(ii)\SourceFile)
        ReadData(0, *Buffer, fsize)
        CloseFile(0)
      Else
        FreeMemory(*Buffer)
        Transferarray(ii)\EntryID = 0 ; diese Datei ausschließen
        MessageRequester("Fehler:", "Die Quelldatei konnte nicht geöffnet werden.")
        runs = #False : ProcedureReturn 0
      EndIf
      ; verschlüsseln wenn verschlüsselt werden soll
      If UseCipher
        ; berechnen aus der Dateigrösse die Anzahl der benötigten Blöcke, um alle Daten der Datei aufzunehmen
        blks = fsize / 16
        If fsize % 16 : blks + 1 : EndIf  ; einen Block mehr wenn ein Rest bleibt 
        ; die letzten 32 Byte vom Buffer mit Zufallwerten füllen
        If OpenCryptRandom() And *Buffer
          CryptRandomData(*Buffer + fsize, 32)
          CloseCryptRandom()
        Else
          MessageRequester("Error", "Key generation is not available")
          End
        EndIf
        ; den Modulowert in letztes Byte schreiben - die Anzahl der zugefügten Zufall-Bytes kann daraus berechnet werden
        PokeA(*Buffer + (blks * 16) + 15, fsize % 16) 
        *CiphBuff = AllocateMemory(blks * 16)
        ; entschlüsseln
        If Not AESEncoder(*Buffer, *CiphBuff, blks * 16, *CipherKey, 256, *Buffer + (blks * 16), #PB_Cipher_CBC) ; verschlüsseln
          FreeMemory(*Buffer)
          FreeMemory(*CiphBuff)
          MessageRequester("Fehler:", "Eine Datei konnte nicht verschlüsselt werden.")
          runs = #False : ProcedureReturn 0 
        EndIf        
        CopyMemory(*CiphBuff, *Buffer, blks * 16) ; copies ciphered range back to *Buffer
        FreeMemory(*CiphBuff)
        fsize = (blks * 16) + 16 ; die Dateigrösse ändert sich bei verschlüsselter Datei
        Transferarray(ii)\TargetFile = Transferarray(ii)\TargetFile + ".aes"
      EndIf
      ; Speicher in eine temporäre Datei laden
      If CreateFile(0, temppath + "temp")   ; eine neue temporäre Datei...
        WriteData(0, *Buffer, fsize)        ; alle verschlüsselten Zeichen + den IniVector in die tmp-Datei schreiben
        CloseFile(0)                        ; die Datei schließen
        FreeMemory(*Buffer)
      Else
        FreeMemory(*Buffer)
        MessageRequester("Fehler:", "Die temporäre Datei konnte nicht erstellt werden.")
        runs = #False : ProcedureReturn 0
      EndIf
      ; temporäre Datei uploaden
      If SendFTPFileEx(NetID, (temppath + "temp"), (Transferarray(ii)\TargetFile), 1, @ErrorOutput$)
        If Not TransferComplete()
          MessageRequester("Fehler:", "Die Datei konnte nicht hochgeladen werden.")
          Transferarray(ii)\EntryID = 0 ; diese Datei ausschließen
          runs = #False : ProcedureReturn 0
        EndIf  
        AddMsg("Upload ''" + GetFilePart(Transferarray(ii)\SourceFile) + "''")
      Else
        MessageRequester("Fehler:", "Die Datei konnte nicht hochgeladen werden.")
        Transferarray(ii)\EntryID = 0   ; diese Datei ausschließen
        runs = #False : ProcedureReturn 0
      EndIf  
      Transferarray(ii)\EntryID = 0     ; diese Datei zukünftig ausschließen
      DeleteFile(temppath + "temp") 
    EndIf  
  Next
  RestoreHostList()
  runs = #False : ProcedureReturn 1
EndProcedure


Procedure btnUploadEvent(EventType)
  ; file-upload, multiple selection possible
  If runs : ProcedureReturn : EndIf
  If NetID
    Shared Transferarray()
    Define ii.l
    Define jj.l
    Define cnt.l
    Define xfile.s
    For ii = 1 To CountGadgetItems(LocalList) - 1   ; ii-loop
      If GetGadgetItemState(LocalList, ii) = 5      ; only upload selected files (not folder)
        ReDim Transferarray.RowStruc(cnt)
        Transferarray(cnt)\EntryID = ii
        xfile = GetGadgetItemText(LocalList, ii)        ; get the filename of the ii-loop
        If UseCipher : xfile = xfile + ".aes" : EndIf   ; add ".aes" if cipher is chosen
        For jj = 1 To CountGadgetItems(HostList) - 1
          If xfile = GetGadgetItemText(HostList, jj)    ; compare the file of the ii-loop and the file of the jj-loop
            If Overwrite = 0
              If MessageRequester("Frage:", "''" + xfile + "''" + #LF$ + #LF$ + 
                                        "Diese Datei existiert bereits im Zielverzeichnis." + #LF$ + 
                                        "Soll sie überschrieben werden?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_No
                ProcedureReturn
              EndIf  
            EndIf
          EndIf
        Next
        Transferarray(cnt)\SourceFile = GetGadgetText(LocalList) + GetGadgetItemText(LocalList, ii) ; folder + file
        Transferarray(cnt)\TargetFile = HostFolder + GetGadgetItemText(LocalList, ii)
        cnt + 1
      EndIf  
    Next
    runs = #True
    CreateThread(@FileUpload(), 0)
  EndIf
EndProcedure


Procedure btnCancelEvent(EventType)
  ; program terminate
  CloseMainWindow = 1
EndProcedure


Procedure WriteProfil()
  ; write the preferences back to the INI-File
  If OpenPreferences("ftp.ini", #PB_Preference_GroupSeparator)
    PreferenceGroup("Global")
    WritePreferenceString("TextLocal", TxtLocalstr)
    WritePreferenceString("TextHost", TxtHoststr)
    WritePreferenceLong("Overwrite", Overwrite)
    WritePreferenceLong("TooltipsOff", TooltipsOff)
    WritePreferenceLong("AppPathForTemp", AppPathForTemp)
    PreferenceGroup(selProfile)
    WritePreferenceString("LocalFolder", LocalFolder)
    WritePreferenceString("HostFolder", HostFolder)
    WritePreferenceString("DnLdFolder", DnLdFolder)
    WritePreferenceLong("Protocol", Protocol)
    WritePreferenceString("HostURL", HostURL)
    WritePreferenceLong("HostPort", HostPort)
    WritePreferenceString("HostUser", HostUser)
    WritePreferenceString("HostPass", EncodePW(HostPass))
    WritePreferenceLong("UseCipher", UseCipher)
    WritePreferenceString("CipherCode", CipherCode)
    ClosePreferences()
  Else
    MessageRequester("Error", "Can't write the file 'ftp.ini'.")
  EndIf
EndProcedure


;#########################################################################################################  
  ; Einstellungen-Fenster
    
Procedure btnPreferencesEvent(EventType)
  ; verhindern, dass noch ein weiteres Toolfenster geöffnet wird
  If IsWindow(PrefWindow) Or IsWindow(HelpWindow) : ProcedureReturn : EndIf
  ; verhindern, dass das Einstellfenster geöffnet wird, wenn eine FTP-Verbindung besteht
  If NetID 
    MessageRequester("easyFTP", "Sie sind mit einem FTP-Server verbunden." + #LF$ +
                                "Bitte trennen Sie erst die Verbindung.")  
    ProcedureReturn 
  EndIf
   ; Einstellungen-Fenster öffnen und Werte anzeigen
  Define ii.l, nrsel.l
  OpenPrefWindow()
  SetGadgetText(strPrefHostURL, HostURL)
  SetGadgetText(strPrefHostPort, Str(HostPort))
  SetGadgetText(strPrefHostUser, HostUser)
  SetGadgetText(strPrefHostPass, HostPass)
  SetGadgetText(strPrefDnLdFolder, DnLdFolder)
  SetGadgetText(strPrefTxtLocal, TxtLocalstr)
  SetGadgetText(strPrefTxtHost, TxtHoststr)
  SetGadgetState(chkPrefOverwrite, Overwrite)
  SetGadgetState(chkPrefTooltips, TooltipsOff)
  SetGadgetState(chkPrefTempPath, AppPathForTemp)
  SetGadgetText(strPrefCipherCode, CipherCode)
  SetGadgetState(chkPrefUseCipher, UseCipher)
  If Not TooltipsOff ; create tooltips
    GadgetToolTip(btnProf, "Profile neu anlegen, klonen, umbenennen oder löschen")
    GadgetToolTip(comPrefProfil, "Profil auswählen")
    GadgetToolTip(strPrefDnLdFolder, "Pfad auf dem Server, der die FTP-Freigabe enthält. Beispiel: www.mydomain.de/myfolder")
    GadgetToolTip(strPrefCipherCode, "Schlüssel: 32 zweistellige Hex-Werte durch Leerzeichen getrennt")
    GadgetToolTip(btnPrefGenNewKey, "öffnet ein Fenster, auf dem durch eine Mausbewegung ein neuer Schlüssel erstellt wird")
    GadgetToolTip(chkPrefTempPath, "alternativ wird dafür das temporäre Verzeichnis auf dem PC des Anwenders genutzt")
  EndIf
  ; Protocol-Liste 
  AddGadgetItem(comPrefProtocol, 0,"FTP")
  AddGadgetItem(comPrefProtocol, 1,"SFTP")
  AddGadgetItem(comPrefProtocol, 2,"FTPS_Implicit")
  AddGadgetItem(comPrefProtocol, 3,"FTPS_Explicit")
  SetGadgetState(comPrefProtocol, Protocol - 1) ; Auswahl setzen
  ; Profile-Liste
  For ii = 1 To CountString(existProfiles, "°°°")
    AddGadgetItem(comPrefProfil, -1, StringField(existProfiles, ii, "°°°"))
    If StringField(existProfiles, ii, "°°°") = selProfile
      nrsel = ii - 1
    EndIf  
  Next  
  SetGadgetState(comPrefProfil, nrsel)
  SetActiveGadget(comPrefProfil)
EndProcedure


Procedure btnProfMenue(EventType)
  ; zeigt das Menü zum Profileverändern 
  DisplayPopupMenu(2, WindowID(Prefwindow))
EndProcedure


Procedure comSelectedProfile(EventType)
  ; ändert die Einstellungen im Einstellungen-Fenster
  If EventType = #PB_EventType_Change
    SetPrefWindowGadgeds()
  EndIf  
EndProcedure


Procedure btnGenerateNewKey(EventType)
  ; neuen Key generieren
  Define X.l
  Define Y.l
  Define ii.l
  Define iiold.l = 65536 ; dieser Wert kommt bei ii nie vor 
  Define cntr.l
  Define newKey.s
  Define *Buffer = AllocateMemory(65536)
  ; Schlüssel-Erzeugen-Fenster öffnen
  Define MouseWindow = OpenWindow(#PB_Any, 0, 0, 256, 256, "easyFTP", #PB_Window_WindowCentered, WindowID(PrefWindow))
  TextGadget(#PB_Any, 10, 6, 236, 40, "Um den Schlüssel zu erzeugen bewegen Sie die Maus über dieses Fenster.")
  ; den Buffer mit Zufallzahlen füllen
  If OpenCryptRandom() And *Buffer
    CryptRandomData(*Buffer, 65536)
    CloseCryptRandom()
  Else
    MessageRequester("Error", "Key generation is not available")
    End
  EndIf
  ; Die Positionen während der Mausbewegung ermitteln und
  ; die entsprechenden Zufallzahlen aus dem Buffer in die Keyliste eintragen.  
  Repeat
    WindowEvent()
    X = WindowMouseX(MouseWindow)
    Y = WindowMouseY(MouseWindow)
    ii = X + (Y * 256)
    If (X > -1) And (X < 256) And (Y > -1) And (Y < 256) And (ii <> iiold) ; geht bei Windows und bei Linux
      newKey + " " + RSet(Hex(PeekB(*Buffer + ii), #PB_Byte), 2, "0")
      iiold = ii
      cntr + 1
    EndIf    
    Delay(20)
  Until cntr = 32 ; CloseWindow
  FreeMemory(*Buffer)
  MessageRequester("easyFTP", "Der Schlüssel wurde erzeugt.")
  CloseWindow(MouseWindow)
  SetGadgetText(strPrefCipherCode, LTrim(newKey))
EndProcedure

  
Procedure btnPrefSaveEvent(EventType)
  ; Einstellungen-Fenster schließen und Einstellungen übernehmen
  Define tmpstr.s, rdCipCo.s, profl.s, ii.l
;  ; workaround wegen gelegentlicher Fehler
;  If Not IsGadget(comPrefProfil) : Debug "Fehler in btnPrefSaveEvent" : ProcedureReturn : EndIf
  ; Profil-Liste auslesen
  If GetGadgetState(comPrefProfil) <> -1 
    profl = GetGadgetItemText(comPrefProfil, GetGadgetState(comPrefProfil))  
  EndIf
  If profl = "" : ProcedureReturn : EndIf ; ohne Profil keine Sicherung der Eigenschaften (kommt beim aller ersten Start zum Einsatz)
  ; Schlüssel prüfen
  tmpstr = UCase(GetGadgetText(strPrefCipherCode))
  ReplaceString(tmpstr, "-", " ", #PB_String_InPlace)
  ReplaceString(tmpstr, ",", " ", #PB_String_InPlace)
  ; das aktuelle Profil auslesen
  OpenPreferences("ftp.ini", #PB_Preference_GroupSeparator)
  PreferenceGroup(profl)
  rdCipCo = ReadPreferenceString("CipherCode", "")
  ClosePreferences()      
  ; Warnung wenn Key verändert wurde - ausser bei neuen Profilen (zu erkennen an rdCipCo = "") 
  If (rdCipCo <> tmpstr) And (rdCipCo <> "") 
    If MessageRequester("Achtung:", "Der Schlüssel wurde verändert. Wenn Sie jetzt auf 'Ja' klicken wird" + #LF$ +
                                    "der alte Schlüssel überschrieben. Sie können danach die Dateien" + #LF$ +
                                    "nicht mehr öffnen, die mit dem alten Schlüssel verschlüsselt wurden." + #LF$ +
                                    "Brechen Sie den Vorgang ab, indem Sie das Einstellungen-Fenster" + #LF$ +
                                    "schließen. Öffenen Sie es dann erneut und kopieren Sie den alten" + #LF$ +
                                    "Schlüssel über die Zwischenablage in eine Datei, bevor Sie den" + #LF$ +
                                    "Vorgang wiederholen. Sie können dann bei Bedarf den Schlüssel später" + #LF$ +
                                    "hier wieder einsetzen." + #LF$ +
                                    "" + #LF$ +
                                    "Wollen Sie den neuen Schlüssel speichern und" + #LF$ +
                                    "den vorhandenen damit überschreiben?", 
                        #PB_MessageRequester_YesNo) = #PB_MessageRequester_No
      ProcedureReturn
    EndIf  
  EndIf    
  CipherCode = tmpstr
  Protocol = GetGadgetState(comPrefProtocol) + 1
  HostURL = GetGadgetText(strPrefHostURL)
  HostPort = Val(GetGadgetText(strPrefHostPort))
  HostUser = GetGadgetText(strPrefHostUser)
  HostPass = GetGadgetText(strPrefHostPass)
  DnLdFolder = GetGadgetText(strPrefDnLdFolder)
  DnLdFolder = RTrim(DnLdFolder, "/")     ; prevent a double slash
  TxtLocalstr = GetGadgetText(strPrefTxtLocal)
  TxtHoststr = GetGadgetText(strPrefTxtHost)
  Overwrite = GetGadgetState(chkPrefOverwrite)
  TooltipsOff = GetGadgetState(chkPrefTooltips)
  SetToolTips()
  AppPathForTemp = GetGadgetState(chkPrefTempPath)
  UseCipher = GetGadgetState(chkPrefUseCipher)
  If UseCipher
    If MkCipherKey()    ; if correct key
      SetGadgetState(Image0, ImageID(0)) ; show image
    Else        
      UseCipher = 0          ; if wrong key don't use cipher
      SetGadgetState(Image0, 0) ;  if wrong key delete image
    EndIf
  Else
    SetGadgetState(Image0, 0) ; delete image
  EndIf
  ; wenn Profil geändert wurde: Das neues Profil eintragen, die alten Pfade sichern, und die neuen Pfade aus der 'ftp.ini' lesen
  If profl <> selProfile
    OpenPreferences("ftp.ini", #PB_Preference_GroupSeparator)
    PreferenceGroup("Global")
    WritePreferenceString("selProfile", profl)
    PreferenceGroup(selProfile)           ; das alte Profil
    WritePreferenceString("LocalFolder", LocalFolder)
    WritePreferenceString("HostFolder", HostFolder)
    PreferenceGroup(profl)                ; das neue Profil
    LocalFolder = ReadPreferenceString("LocalFolder", LocalFolder)
    HostFolder = ReadPreferenceString("HostFolder", HostFolder)
    ClosePreferences()
    ; die Variable 'existProfiles' nach der comPrefProfil neu aufbauen
    existProfiles = ""
    For ii = 1 To CountGadgetItems(comPrefProfil)
      existProfiles = existProfiles + GetGadgetItemText(comPrefProfil, ii - 1) + "°°°"
    Next
    ; überflüssige Profile aus der 'ftp.ini' entfernen
    OpenPreferences("ftp.ini", #PB_Preference_GroupSeparator)
    ExaminePreferenceGroups()
    While NextPreferenceGroup() ; Solange Gruppen existieren...
      If PreferenceGroupName() <> "Global"
        If Not FindString(existProfiles, PreferenceGroupName())
          RemovePreferenceGroup(PreferenceGroupName())
        EndIf  
      EndIf
    Wend
    ClosePreferences()
    selProfile = profl
    ClearGadgetItems(MsgList)
  EndIf  
  WriteProfil() ; write the preferences back to the INI-File
  SetGadgets() ; set the MainWindow Gadgets
  CloseWindow(PrefWindow)
EndProcedure


Procedure btnPrefCancelEvent(EventType)
  ; Einstellungen-Fenster schließen ohne zu speichern
  ;If IsWindow(PrefWindow) : CloseWindow(PrefWindow) : EndIf
  CloseWindow(PrefWindow)
EndProcedure


;#########################################################################################################  
  ; Info-Fenster

DataSection
  infotext:
  IncludeBinary "text.txt"
  Data.b 0 ; String-Ende-Marker
EndDataSection


Procedure btnHelpEvent(EventType)
  ; verhindern, dass noch ein weiteres Toolfenster geöffnet wird
  If (IsWindow(PrefWindow) Or IsWindow(HelpWindow)) : ProcedureReturn : EndIf
  ; Help-Fenster öffnen und Text anzeigen
  OpenHelpWindow()
  SetGadgetState(Image1, ImageID(9)) ; show logo
  SetGadgetText(hlptxt, PeekS(?infotext, -1, #PB_Ascii))
EndProcedure


Procedure btnHelpCancelEvent(EventType)
  ; Hilfe-Fenster schließen
  If IsWindow(HelpWindow) : CloseWindow(HelpWindow) : EndIf
EndProcedure

;#########################################################################################################  
; Mainloop
Repeat
  MWEvent = WaitWindowEvent(20)
  Select EventWindow() 
    Case MainWindow
      If CloseMainWindow : Break : EndIf  ; exit if the cancel button is pressed
      If Not MainWindow_Events(MWEvent)   ; the eventmanager located at "ftp.pbf"
        Break                             ; exit if the (X) button is pressed
      EndIf  
    Case PrefWindow
      If Not PrefWindow_Events(MWEvent)  ; the eventmanager located at "ftppref.pbf"
        CloseWindow(PrefWindow)          ; close if the cancel button or the (X) button is pressed
      EndIf
      If MWEvent = #PB_Event_DeactivateWindow
        SetActiveWindow(PrefWindow)
      EndIf  
    Case HelpWindow
      If Not HelpWindow_Events(MWEvent)  ; the eventmanager located at "ftphelp.pbf"
        CloseWindow(HelpWindow)          ; close if the cancel button or the (X) button is pressed
      EndIf
      If MWEvent = #PB_Event_DeactivateWindow
        SetActiveWindow(HelpWindow)
      EndIf  
  EndSelect
  If MWEvent = #PB_Event_Menu
    PopupMenuEvent()
  EndIf
  If MWEvent = #PB_Event_Timer And EventTimer() = 123
    RemoveWindowTimer(Mainwindow, 123)
    CloseWindow(MsgWindow)
  EndIf    
  ; workaround weil der Eventmanager im HelpWindow nicht funktioniert wenn vorher das PrefWindow aufgerufen war
  If EventWindow() = HelpWindow And MWEvent = #PB_Event_Gadget And EventGadget() = btnHelpCancel 
    btnHelpCancelEvent(MWEvent)
  EndIf
ForEver  
;  
If NetID : CloseFTPEx(NetID, @ErrorOutput$) : NetID = 0 : EndIf ; falls Verbindung noch offen -> schließen  
CloseFTPLibrary()
;
; write the preferences back to the INI-File
OpenPreferences("ftp.ini", #PB_Preference_GroupSeparator)
PreferenceGroup(selProfile)           ; das alte Profil
WritePreferenceString("LocalFolder", LocalFolder)
WritePreferenceString("HostFolder", HostFolder)
ClosePreferences()
;
End

;#########################################################################################################  
;#########################################################################################################  
;#########################################################################################################  


; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 148
; FirstLine = 124
; Folding = ------
; EnableXP